## ros-rolling-rc-genicam-driver 0.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(rc_genicam_driver)

include(cmake/project_version.cmake)

# Default to C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

# find dependencies
find_package(ament_cmake REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(stereo_msgs REQUIRED)
find_package(rc_common_msgs REQUIRED)
find_package(diagnostic_updater REQUIRED)
find_package(image_transport REQUIRED)
find_package(RC_GENICAM_API 2.4.4 REQUIRED)

set(NODE_NAME rc_genicam_driver)
set(LIB_NAME ${NODE_NAME}_core)

set(DEPS
  rclcpp
  rclcpp_components
  sensor_msgs
  stereo_msgs
  rc_common_msgs
  diagnostic_updater
  image_transport
)

include_directories(
  ${RC_GENICAM_API_INCLUDE_DIRS}
)

add_library(${LIB_NAME} SHARED
  src/genicam_driver.cpp
  src/publishers/camera_info_publisher.cpp
  src/publishers/camera_param_publisher.cpp
  src/publishers/confidence_publisher.cpp
  src/publishers/depth_publisher.cpp
  src/publishers/disparity_color_publisher.cpp
  src/publishers/disparity_publisher.cpp
  src/publishers/error_depth_publisher.cpp
  src/publishers/error_disparity_publisher.cpp
  src/publishers/image_publisher.cpp
  src/publishers/points2_publisher.cpp
)

ament_target_dependencies(${LIB_NAME}
  ${DEPS}
)

target_link_libraries(${LIB_NAME}
  rc_genicam_api::rc_genicam_api
)

add_executable(${NODE_NAME}
  src/genicam_driver_main.cpp
)

target_link_libraries(${NODE_NAME} ${LIB_NAME})

rclcpp_components_register_nodes(${LIB_NAME} "rc::GenICamDriver")
set(node_plugins "${node_plugins}rc::GenICamDriver;$<TARGET_FILE:rc_genicam_driver>\n")

install(TARGETS ${NODE_NAME} ${LIB_NAME}
  EXPORT export_${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION lib/${PROJECT_NAME}
)

#install(DIRECTORY params
#  DESTINATION share/${PROJECT_NAME}
#)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

ament_export_libraries(${LIB_NAME})
ament_export_dependencies(${DEPS})
ament_package()

######################################
## Define information for packaging ##
######################################
# optionally specify dependencies of the debian package here (comma separated!)
set(CPACK_DEBIAN_PACKAGE_DEPENDS "ros-$ENV{ROS_DISTRO}-rc-common-msgs, rc-genicam-api (>= 2.4.4) | ros-$ENV{ROS_DISTRO}-rc-genicam-api (>= 2.4.4)")
include(cmake/package_debian.cmake)

## ros-rolling-rc-genicam-driver 0.2.1

=== debian/changelog ===
ros-rolling-rc-genicam-driver (0.2.1-1focal) focal; urgency=high

  * Add exposure_adapt_timeout parameter
  * warn instead of info if parameter can't be set
  * fix line_source and add more extra_data to CameraParam

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 14 Nov 2021 23:00:00 -0000

ros-rolling-rc-genicam-driver (0.2.0-1focal) focal; urgency=high

  For supporting rc_sgm_producer:
  * Extend color format to RGB8 for ros foxy
  * Using parameter PtpEnable instead of deprecated parameter GevIEEE1588

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 01 Aug 2021 22:00:00 -0000

ros-rolling-rc-genicam-driver (0.1.4-1focal) focal; urgency=high

  * Accept devices from vendor Roboception or if model is rc_visard or rc_cube

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 10 Feb 2021 23:00:00 -0000

ros-rolling-rc-genicam-driver (0.1.3-1focal) focal; urgency=high

  * Use image_transport.hpp to get rid of a warning and hence drop eloquent support
  * Use C-strings for RCLCPP macros to support rolling

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 01 Feb 2021 23:00:00 -0000

ros-rolling-rc-genicam-driver (0.1.2-1focal) focal; urgency=high

  * fix linking problems

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 28 Jan 2021 23:00:00 -0000

ros-rolling-rc-genicam-driver (0.1.1-1focal) focal; urgency=high

  * fix typo in package xml

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 17 Jan 2021 23:00:00 -0000

ros-rolling-rc-genicam-driver (0.1.0-1focal) focal; urgency=high

  * initial release

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 17 Jan 2021 23:00:00 -0000

=== debian/control ===
Source: ros-rolling-rc-genicam-driver
Section: misc
Priority: optional
Maintainer: Felix Ruess <felix.ruess@roboception.de>
Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake, ros-rolling-ament-cmake-cppcheck, ros-rolling-ament-cmake-xmllint, ros-rolling-ament-lint-auto, ros-rolling-diagnostic-updater, ros-rolling-image-transport, ros-rolling-rc-common-msgs, ros-rolling-rc-genicam-api, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-sensor-msgs, ros-rolling-stereo-msgs, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-rc-genicam-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-diagnostic-updater, ros-rolling-image-transport, ros-rolling-rc-common-msgs, ros-rolling-rc-genicam-api, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-sensor-msgs, ros-rolling-stereo-msgs, ros-rolling-ros-workspace
Description: Driver for rc_visard and rc_cube from Roboception GmbH

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-rc-genicam-driver//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-rc-genicam-driver 0.3.0

=== debian/changelog ===
ros-rolling-rc-genicam-driver (0.3.0-2jammy) jammy; urgency=high

  * Replaced parameter camera_exp_auto by camera_exp_control and camera_exp_auto_mode for consistency
  * Change parameters camera_exp_max and camera_exp_value so unit seconds for consistency
  * Added Gamma parameter
  * only publish high/low if the publisher exists
  * fix if iocontrol is not available

 -- Felix Ruess <felix.ruess@roboception.de>  Fri, 10 Mar 2023 08:00:00 -0000

ros-rolling-rc-genicam-driver (0.2.1-2jammy) jammy; urgency=high

  * Add exposure_adapt_timeout parameter
  * warn instead of info if parameter can't be set
  * fix line_source and add more extra_data to CameraParam

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 15 Nov 2021 08:00:00 -0000

ros-rolling-rc-genicam-driver (0.2.0-2jammy) jammy; urgency=high

  For supporting rc_sgm_producer:
  * Extend color format to RGB8 for ros foxy
  * Using parameter PtpEnable instead of deprecated parameter GevIEEE1588

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 02 Aug 2021 07:00:00 -0000

ros-rolling-rc-genicam-driver (0.1.4-2jammy) jammy; urgency=high

  * Accept devices from vendor Roboception or if model is rc_visard or rc_cube

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 11 Feb 2021 08:00:00 -0000

ros-rolling-rc-genicam-driver (0.1.3-2jammy) jammy; urgency=high

  * Use image_transport.hpp to get rid of a warning and hence drop eloquent support
  * Use C-strings for RCLCPP macros to support rolling

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 02 Feb 2021 08:00:00 -0000

ros-rolling-rc-genicam-driver (0.1.2-2jammy) jammy; urgency=high

  * fix linking problems

 -- Felix Ruess <felix.ruess@roboception.de>  Fri, 29 Jan 2021 08:00:00 -0000

ros-rolling-rc-genicam-driver (0.1.1-2jammy) jammy; urgency=high

  * fix typo in package xml

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 18 Jan 2021 08:00:00 -0000

ros-rolling-rc-genicam-driver (0.1.0-2jammy) jammy; urgency=high

  * initial release

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 18 Jan 2021 08:00:00 -0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: misc
 Priority: optional
 Maintainer: Felix Ruess <felix.ruess@roboception.de>
-Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake, ros-rolling-ament-cmake-cppcheck, ros-rolling-ament-cmake-xmllint, ros-rolling-ament-lint-auto, ros-rolling-diagnostic-updater, ros-rolling-image-transport, ros-rolling-rc-common-msgs, ros-rolling-rc-genicam-api, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-sensor-msgs, ros-rolling-stereo-msgs, ros-rolling-ros-workspace
+Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake, ros-rolling-ament-cmake-cppcheck <!nocheck>, ros-rolling-ament-cmake-xmllint <!nocheck>, ros-rolling-ament-lint-auto <!nocheck>, ros-rolling-diagnostic-updater, ros-rolling-image-transport, ros-rolling-rc-common-msgs, ros-rolling-rc-genicam-api, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-sensor-msgs, ros-rolling-stereo-msgs, ros-rolling-ros-workspace
 Homepage: 
 Standards-Version: 3.9.2

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
